package org.jboss.errai.ui.nav.client.local.spi;

import java.util.HashMap;
import java.util.Map;
import org.jboss.errai.demo.test.client.local.Page1;
import org.jboss.errai.demo.test.client.local.Page2;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.container.async.CreationalCallback;
import org.jboss.errai.ui.nav.client.local.DefaultPage;
import org.jboss.errai.ui.nav.client.local.HistoryToken;
import org.jboss.errai.ui.nav.client.local.NavigationEvent;
import org.jboss.errai.ui.nav.client.local.PageRequest;

public class GeneratedNavigationGraph extends NavigationGraph {
  public GeneratedNavigationGraph() {
    final PageNode page2 = new PageNode<Page2>() {
      public String name() {
        return "Page2";
      }

      public Class contentType() {
        return Page2.class;
      }

      public void produceContent(CreationalCallback callback) {
        bm.lookupBean(Page2.class).getInstance(callback);
      }

      public void pageHiding(Page2 widget) {

      }

      public void pageHidden(Page2 widget) {

      }

      public native void _$174411376_pageShowing(Page2 instance, HistoryToken a0) /*-{
        instance.@org.jboss.errai.demo.test.client.local.Page2::pageShowing(Lorg/jboss/errai/ui/nav/client/local/HistoryToken;)(a0);
      }-*/;

      public void pageShowing(Page2 widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
        CDI.fireEvent(new NavigationEvent(new PageRequest("Page2", pageState)));
        _$174411376_pageShowing(widget, state);
      }

      public void pageShown(Page2 widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
      }
    };
    pagesByName.put("Page2", page2);
    final PageNode defaultPage = new PageNode<Page1>() {
      public String name() {
        return "Page1";
      }

      public Class contentType() {
        return Page1.class;
      }

      public void produceContent(CreationalCallback callback) {
        bm.lookupBean(Page1.class).getInstance(callback);
      }

      public void pageHiding(Page1 widget) {

      }

      public void pageHidden(Page1 widget) {

      }

      public native void _$174411377_pageShowing(Page1 instance, HistoryToken a0) /*-{
        instance.@org.jboss.errai.demo.test.client.local.Page1::pageShowing(Lorg/jboss/errai/ui/nav/client/local/HistoryToken;)(a0);
      }-*/;

      public void pageShowing(Page1 widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
        CDI.fireEvent(new NavigationEvent(new PageRequest("Page1", pageState)));
        _$174411377_pageShowing(widget, state);
      }

      public void pageShown(Page1 widget, HistoryToken state) {
        final Map pageState = new HashMap() {
          {

          }
        };
      }
    };
    pagesByName.put("", defaultPage);
    pagesByRole.put(DefaultPage.class, defaultPage);
    final PageNode page1 = defaultPage;
    pagesByName.put("Page1", page1);
  }

}